#include "GFXframework.h"

#include <iostream>

GFXframework* GFXframework::m_GFXframework= NULL;

GFXframework::GFXframework()
{   
	
}

GFXframework::~GFXframework()
{   
	m_Window->close();
	delete m_Window;
}

GFXframework* GFXframework::GetInstance()
{
	if (m_GFXframework== NULL) 
	{
		m_GFXframework = new GFXframework();
	}
	return m_GFXframework;
}

void GFXframework::ResetInstance()
{
	delete m_GFXframework; // REM : it works even if the pointer is NULL (does nothing then)
	m_GFXframework = NULL; // so GetInstance will still work.
}

bool GFXframework::InitWindow(int sizeX, int sizeY, char* name)
{
	m_Window = new sf::RenderWindow(sf::VideoMode(sizeX, sizeY), name);
	return true;
}

sf::RenderWindow* GFXframework::GetWindow() 
{ 
	return m_Window;
}

void GFXframework::LoadSprites()
{
	m_TileTexture[0].loadFromFile("0.png");
	m_TileTexture[1].loadFromFile("1.png");
	m_TileTexture[2].loadFromFile("2.png");
	m_TileTexture[3].loadFromFile("3.png");
	m_TileTexture[4].loadFromFile("4.png");
	m_TileTexture[5].loadFromFile("5.png");
	m_TileTexture[6].loadFromFile("6.png");
	m_TileTexture[7].loadFromFile("7.png");
	m_TileTexture[8].loadFromFile("8.png");
	m_TileTexture[9].loadFromFile("bomb.png");
	m_TileTexture[10].loadFromFile("happy.png");
	m_TileTexture[11].loadFromFile("ground.png");
	m_TileTexture[12].loadFromFile("flag.png");
	
	for (int i = 0; i < 13; i++)
	{		
		m_Sprite[i] =sf::Sprite(m_TileTexture[i]); 
	}	
}

void GFXframework::DisplaySpriteAt(int spriteType, int x, int y)
{
	m_Sprite[spriteType].setPosition((float)x, (float)y);
	m_Window->draw(m_Sprite[spriteType]);
}