// MAIN GAME CLASS

#ifndef GAME_H
#define GAME_H

class Map;

#include <SFML/Window/Mouse.hpp>
#include <SFML/Graphics.hpp>

class Game
{
private:
	bool m_Finished;
	 
	int m_SizeX;
	int m_SizeY;
	int m_numOfBombs;

	bool m_FirstClick;
	bool m_LeftMouseDown;
	bool m_RightMouseDown;
	
	sf::Texture m_GUITexture;
	sf::Sprite m_GUISprite;
	
	Map* m_LevelMap;

public:
	Game();
	~Game();
	
	
	void Init();
	void Shutdown(int exitCode); // init and shutdown methods, woo
	
	void MainLoop(); // main loop, call that from the MAIN file and you have a game
	bool HandleLeftMouse(sf::Vector2i localPosition);
	bool HandleRightMouse(sf::Vector2i localPosition);
	void HandleGame(); // some cool stuff may go here, eventually

	void DrawGui(); // draw gui... pretty stuff
	void Render(); // render our game. we call this every frame	
};

#endif